<!doctype html>

<form id="join" name="join">
    <label for="username">username</label> <input required id="username" type="text" name="username" maxlength="50"/>
    <label for="locale">locale</label> <select id="locale" name="locale"></select>
    <input id="button-join" type="submit" value="Join"/>
</form>

<form class="hidden" id="chat" name="publish">
    <label for="message">message</label> <input id="message" type="text" name="message" maxlength="180"/>
    <input id="submit-button" type="submit" value="Send"/>
</form>

<style>
    .hidden {
        display: none;
    }
</style>

<div id="messages"></div>

<script>

  let url = 'ws://localhost:8080/ws'
  let socket = new WebSocket(url);

  socket.onmessage = function (event) {
    let incomingMessage = event.data;
    const parsedResponse = JSON.parse(incomingMessage);
    showMessage(parsedResponse);
  };

  socket.onclose = event => console.log(`Closed ${event.code}`);
  // send message from the form
  const publishForm = document.getElementById('chat');
  const joinForm = document.getElementById('join');

  joinForm.onsubmit = function (e) {
    e.preventDefault();
    const user = {
      username: joinForm.username.value,
      locale: joinForm.locale.value,
    };

    if (!user.username) {
      alert('please enter an username')
    }

    socket.send(JSON.stringify({
      user
    }));

    publishForm.classList.remove('hidden');
    joinForm.classList.add('hidden');
  }

  publishForm.onsubmit = function (e) {
    e.preventDefault();
    socket.send(JSON.stringify({message: publishForm.message.value}));
  };

  // show message in div#messages
  function showMessage(sending) {
    let messageElem = document.createElement('div');
    messageElem.textContent = `${sending.username}: ${sending.message}`;
    document.getElementById('messages').prepend(messageElem);
  }

  async function setSelections() {
    const {result} = await (await fetch('http://localhost:8080/languages')).json();
    const localeSelection = document.getElementById('locale');
    result.forEach((option) => localeSelection.add(new Option(option.name, option.locale)))
  }

  setSelections();
</script>
